/////////////////////////////////////////
// stuff to init socks and get local hostname
#define WSADESCRIPTION_LEN      256
#define WSASYS_STATUS_LEN       128

typedef strWSAData
begin
	NUMBER	wVersion;
	NUMBER	wHighVersion;
	char szDescription[WSADESCRIPTION_LEN + 1];
	char szSystemStatus[WSASYS_STATUS_LEN + 1];
	short	iMaxSockets;
	short	iMaxUdpDg;
    pointer lpVendorInfo;
end;

prototype ws2_32.gethostname( BYREF STRING, NUMBER );
prototype ws2_32.WSAStartup( NUMBER, strWSAData POINTER );
//////////////////////////////////

// used with service functions
typedef SERVICE_STATUS
begin
    LONG dwServiceType;
    LONG dwCurrentState;
    LONG dwControlsAccepted;
    LONG dwWin32ExitCode;
    LONG dwServiceSpecificExitCode;
    LONG dwCheckPoint;
    LONG dwWaitHint;
end;

// used in service.rul
#define SERVICE_STOPPED			0x00000001
#define SERVICE_STOP_PENDING		0x00000003
#define SERVICE_CONTROL_STOP		0x00000001
#define SC_MANAGER_ALL_ACCESS		0x000F003F        //WINSVC.H
#define SERVICE_ALL_ACCESS		0x000F01FF
#define SERVICE_NO_CHANGE		0xFFFFFFFF

//errors
#define ERROR_INVALID_PARAMETER             000000087
#define ERROR_ACCESS_DENIED                 000000005
#define ERROR_SUCCESS				0
#define ERROR_DATABASE_DOES_NOT_EXIST       000001065
#define ERROR_CIRCULAR_DEPENDENCY           000001059
#define ERROR_DUP_NAME                      000000052
#define ERROR_INVALID_HANDLE                000000006
#define ERROR_INVALID_NAME                  000000123
#define ERROR_INVALID_SERVICE_ACCOUNT       000001057
#define ERROR_SERVICE_EXISTS                000001073
#define ERROR_PATH_NOT_FOUND                000000003
#define ERROR_SERVICE_ALREADY_RUNNING       000001056
#define ERROR_SERVICE_DATABASE_LOCKED       000001055
#define ERROR_SERVICE_DEPENDENCY_DELETED    000001075
#define ERROR_SERVICE_DEPENDENCY_FAIL       000001068
#define ERROR_SERVICE_DISABLED              000001058
#define ERROR_SERVICE_LOGON_FAILED          000001069
#define ERROR_SERVICE_MARKED_FOR_DELETE     000001072
#define ERROR_SERVICE_NO_THREAD             000001054
#define ERROR_SERVICE_REQUEST_TIMEOUT       000001053
#define ERROR_SERVICE_DOES_NOT_EXIST        000001060
#define ERROR_DEPENDENT_SERVICES_RUNNING    000001051
#define ERROR_INVALID_SERVICE_CONTROL       000001052
#define ERROR_SERVICE_CANNOT_ACCEPT_CTRL    000001061
#define ERROR_SERVICE_NOT_ACTIVE            000001062
#define ERROR_UNKNOWN_SERVICE				000001063
#define ERROR_INSTALL_SERVICE_FAILED		000001064

// my error defines
#define ERROR_SERVICE_FAILED_TO_STOP     000010001
#define ERROR_INIT_VARS                  000010004

////////////////////////////////////
// errors returned from NET API calls in instvc.dll
// from lmerr.h - used in talx.rul
#define NERR_Success			0
#define NERR_BASE				2100
#define NERR_GroupNotFound		(NERR_BASE+120) /* The group name could not be found. */
#define NERR_GroupExists		(NERR_BASE+123) /* The group already exists. */
#define NERR_UserExists			(NERR_BASE+124) /* The user account already exists. */
#define NERR_NotPrimary			(NERR_BASE+126) /* This operation is only allowed on the primary domain controller of the domain. */
#define NERR_PasswordTooShort	(NERR_BASE+145) /* The password is shorter than required. */
#define NERR_InvalidComputer	(NERR_BASE+251) /* This computer name is invalid. */

// from winerr.h
#define ERROR_MEMBER_IN_ALIAS	1378
#define ERROR_NO_SUCH_USER		1387
#define ERROR_INVALID_MEMBER	1388
//////////////////////////////////////

// from shellapi.h -- used indirectly by LaunchMin()
#define SE_ERR_FNF              2       // file not found
#define SE_ERR_PNF              3       // path not found
#define SE_ERR_ACCESSDENIED     5       // access denied
#define SE_ERR_OOM              8       // out of memory
#define SE_ERR_DLLNOTFOUND              32
#define SE_ERR_SHARE                    26
#define SE_ERR_ASSOCINCOMPLETE          27
#define SE_ERR_DDETIMEOUT               28
#define SE_ERR_DDEFAIL                  29
#define SE_ERR_DDEBUSY                  30
#define SE_ERR_NOASSOC                  31

// prototypes from instvc.dll in SUPPORTDIR

// AddUserAccount adds an account to the local system
// Parm1:	Account
// Parm2:	Password
prototype instvc.AddUserAccount( STRING, STRING );

// RemoveUserAccount removes the specified account from the local system
// Parm1:	Account
prototype int instvc.RemoveUserAccount( STRING );

// RegisterFile will register a (COM) file regardless of extension (EXE, DLL, OCX)
// Parm1:	filename
prototype instvc.RegisterFile( STRING );

// UnRegisterFile will unregister a (COM) file regardless of extension (EXE, DLL, OCX)
// Parm1:	filename
prototype instvc.UnRegisterFile( STRING );

// SerServiceRunAs sets the run as information for a server
// this information is normally available through the services applet in the control panel
// Parm1:	serviceName
// Parm2:	Account
// Parm3:	Password
// note: userID == COMPUTERNAME\\ACCOUNTID
prototype LONG instvc.SetServiceRunAs( STRING, STRING, STRING );

// SetPolicy configures passed account to have policy to enable log on as service
// Parm1:	Account
// note: Account == COMPUTERNAME\\ACCOUNTID
prototype instvc.SetPolicy( STRING );

// LaunchMinimized launches a process in a minimized state a waits for completion
// Parm1:	fileName (fully qualified including extension)
// Parm2:	program parameters
// Parm3:	running path
prototype instvc.LaunchMinimized( STRING, STRING, STRING );

// StopService stops the specified service
// Parm1:	serviceName
prototype LONG instvc.StopService( STRING );

// RemoveService removes the specified service
// Parm1:	serviceName
// note: this call should be preceded with a call to StopService()
prototype int instvc.RemoveService( STRING );

// ChangeAppIDAccessACL changes access control to specified AppID for specified principal
// Parm1:	guid = "{CEAAD2E0-3868-11D2-B333-00AA00BD862B}" for example
// Parm2:	Account
// Parm3:	setPrincipal = TRUE sets permissions to that specified in permit, FALSE removes principal from ACL
// Parm4:	permit = TRUE = default access, FALSE = no default access
prototype int instvc.ChangeAppIDAccessACL( STRING, STRING, BOOL, BOOL );

// ChangeAppIDLaunchACL changes launch control to specified AppID for specified principal
// Parm1:	guid = "{CEAAD2E0-3868-11D2-B333-00AA00BD862B}" for example
// Parm2:	Account
// Parm3:	setPrincipal = TRUE sets permissions to that specified in permit, FALSE removes principal from ACL
// Parm4:	permit = TRUE = default access, FALSE = no default access
prototype int instvc.ChangeAppIDLaunchACL( STRING, STRING, BOOL, BOOL );

// SetRunAsPassword sets the run as account for a specified AppID
// Parm1:	guid = "{CEAAD2E0-3868-11D2-B333-00AA00BD862B}" for example
// Parm2:	Account
// Parm3:	password
prototype int instvc.SetRunAsPassword( STRING, STRING, STRING );

// FlushRegistryKey flushes a registry key write to disk
// Parm1:	RegistryKey
// forces any pending writes to the hive to be done
prototype int instvc.FlushRegistryKey( STRING );

// GetMachine returns the name of the current machine
// Parm1:	string to recieve the machine name
prototype int instvc.GetMachineName( BYREF STRING );

// IsWorkGroup returns 1 if this machine is member of a workgroup, 0 otherwise, -1 failure
prototype int instvc.IsWorkgroup();

// IsPrimaryDomainController returns 1 if this machine is a PDC, 0 otherwise, -1 failure
prototype int instvc.IsPrimaryDomainController();

// GetDomainName returns the domain name for the specified machine
// Parm1:	machineName ("\\LabPC")
// Pamr2:	string to receive domain name
prototype int instvc.GetDomainName( STRING, BYREF STRING );

// GetPDCMachineName returns the machine name of the specified PDC, -1 if there is none, 
// Parm1:	machineName ("\\LabPC")
// Parm2:	domainName ("TESTDOMAIN")
// Parm3:	string to receive the PDC machine name
prototype int instvc.GetPDCMachineName( STRING, STRING, BYREF STRING );

// EnumTrustedDomains returns a ';' delimited list of trusted domains in machineName (can be null = local)
// Parm1:	machineName
// Parm2:	string to receive the list of trusted domains
prototype int instvc.EnumTrustedDomains( STRING, BYREF STRING );

// EnumAdminAccounts returns a ';' delimited list of locally defined administrator accounts
// Parm1:	machineName
// Pamr2:	string to receive the list of accounts
prototype instvc.EnumAdminAccounts( STRING, BYREF STRING );

// AddTCBPrivilege adds the TCB privilege to all administrator accounts (defined locally)
// the TCB privilege grants the accounts the ability to log on as a service
prototype int instvc.AddTCBPrivilege();

// Verfies the existence of the TCB privilege on locally defined administrator accounts
// the TCB privilege grants the accounts the ability to log on as a service
prototype int instvc.VerifyTCBPrivilege();
